| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Attributes | List of all members
PythonConfig Class Reference

`#include <src/JobOptionsSvc/PythonConfig.h>`

Collaboration diagram for PythonConfig:
[legend]

## Public Member Functions
| PythonConfig (IJobOptionsSvc *jos)
StatusCode | evaluateConfig (const std::string &filename, const std::string &preAction, const std::string &postAction)

## Private Attributes
SmartIF< IJobOptionsSvc > | m_IJobOptionsSvc

## Detailed Description

Definition at line 25 of file PythonConfig.h.

## Constructor & Destructor Documentation

PythonConfig::PythonConfig | ( | IJobOptionsSvc * | jos | ) |
| inline

Definition at line 28 of file PythonConfig.h.

28 : m_IJobOptionsSvc( jos ){};
PythonConfig::m_IJobOptionsSvc
SmartIF< IJobOptionsSvc > m_IJobOptionsSvc
Definition: PythonConfig.h:32

## Member Function Documentation

StatusCode PythonConfig::evaluateConfig | ( | const std::string & | filename,
|  | const std::string & | preAction,
|  | const std::string & | postAction
| ) |  |

Definition at line 8 of file PythonConfig.cpp.

8 {
9 try{
10 // Prepare a Python environment
11 Py_Initialize();
12 object main_module((
13 handle<>(borrowed(PyImport_AddModule("__main__")))));
14 object main_namespace = main_module.attr("__dict__");
15
16 // make the translator class known to Python
17 main_namespace["PythonAdaptor"] = class_<PythonAdaptor>("PythonAdaptor", boost::python::init<IJobOptionsSvc*>())
18 .def("addPropertyToJobOptions",&PythonAdaptor::addPropertyToJobOptions);
19
20 // create an instance of it and pass it to Python
21 PythonAdaptor adaptor(m_IJobOptionsSvc);
22 main_namespace["adaptor"] = ptr(&adaptor);
23
24 // some python helper
25 std::string command(preAction);
26 command += "\nfor name in '";
27 command += filename + "'.split(','): execfile(name)\n";
28 command += "from GaudiKernel.Configurable import expandvars\nfrom GaudiKernel.Proxy.Configurable import applyConfigurableUsers\napplyConfigurableUsers()\n";
29 command += postAction;
30 command += "\nfor n, c in Configurable.allConfigurables.items():\n for p, v in c.getValuedProperties().items() :\n v = expandvars(v)\n if type(v) == str : v = '\"%s\"' % v # need double quotes\n elif type(v) == long: v = '%d' % v # prevent pending 'L'\n adaptor.addPropertyToJobOptions(n,p,str(v))";
31
32 // Now fire off the translation
33 handle<> ignored(( PyRun_String( command.c_str(),
34 Py_file_input,
35 main_namespace.ptr(),
36 main_namespace.ptr() ) ));
37 } catch( error_already_set ) {
38 std::cout << "Error in python script:" << std::endl;
39 PyErr_Print();
40 return StatusCode::FAILURE;
41 }
42
43 return StatusCode::SUCCESS;
44 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
StatusCode::FAILURE
Definition: StatusCode.h:29
std::endl
T endl(T...args)
PythonAdaptor::addPropertyToJobOptions
void addPropertyToJobOptions(const std::string &client, const std::string &name, const std::string &value)
Definition: PythonConfig.h:15
std::string
STL class.
brunelWrapper.command
string command
Definition: brunelWrapper.py:85
PythonAdaptor
Definition: PythonConfig.h:11
PythonConfig::m_IJobOptionsSvc
SmartIF< IJobOptionsSvc > m_IJobOptionsSvc
Definition: PythonConfig.h:32
std::cout

## Member Data Documentation

SmartIF<IJobOptionsSvc> PythonConfig::m_IJobOptionsSvc
| private

Definition at line 32 of file PythonConfig.h.

The documentation for this class was generated from the following files:

- GaudiCoreSvc/src/JobOptionsSvc/PythonConfig.h
- GaudiCoreSvc/src/JobOptionsSvc/PythonConfig.cpp